/*
 * $Id: brcFonts.h,v 1.1 1991/09/20 19:10:24 mtranle Exp $
 *
 * Copyright IBM Corporation 1987,1990
 *
 * All Rights Reserved
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted,
 * provided that the above copyright notice appear in all copies and that 
 * both that copyright notice and this permission notice appear in
 * supporting documentation, and that the name of IBM not be
 * used in advertising or publicity pertaining to distribution of the
 * software without specific, written prior permission.
 *
 * IBM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
 * ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL
 * IBM BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
 * ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
 * ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
 * SOFTWARE.
 *
*/
/*
 * PRPQ 5799-PFF (C) COPYRIGHT IBM CORPORATION 1987,1990
 * LICENSED MATERIALS - PROPERTY OF IBM
 * REFER TO COPYRIGHT INSTRUCTIONS FORM NUMBER G120-2083
 */
/*
 *  Hardware interface routines for IBM 8514/A adapter for
 *  X.11 server(s) on IBM equipment.
 *
 */

typedef struct _InstalledChar
{
    unsigned short int x ;
    unsigned short int y ;	/* this is relative to the first cached line */
    unsigned short int w ;
    unsigned short int h ;
    CharInfoPtr pInfo ;
} InstalledCharRec, *InstalledCharPtr ;

typedef struct _InstalledFont
{
    unsigned short int	CacheIndex ;
    unsigned short int	startline ;
    unsigned short int	cacheheight ;
    unsigned short int	firstchar ;
    unsigned short int	lastchar ;
    unsigned short int	numchars ;
    InstalledCharPtr	*ppCharacter ;
    struct _InstalledFont *NextFont ;
    FontPtr		pFont ; /* The X font from which it came */
} InstalledFontRec, *InstalledFontPtr ;

typedef struct _ibm8514FontCacheEntry
{
    unsigned long int	RPlaneMask ;
    unsigned long int	WPlaneMask ;
    int			numInstalled ;
    unsigned short int	FirstAvailableLine ;
    unsigned short int	NumLinesAvailable ;
    InstalledFontPtr 	FontList ;
} ibm8514FontCacheRec, *ibm8514FontCachePtr ;

#define FONTCACHESTARTLINE	801
#define FONTCACHELENGTH		222
#define FONTCACHEWIDTH		1024
#define FONTCACHEBYTEWIDTH	128
#define NUMFONTPLANES		6    /* save 1 for stage, 1 for fill */
